#include "guidemo.bi"
#include "stats.bi"

Dim Shared As UI_BOX_PTR gOptions, gTest2, gCapRate
Dim Shared fnt As JM_FONT_PTR	= 0
Dim Shared gQuit As Integer	= 0
Dim Shared gLastKey As Integer = 0
Dim Shared As Integer gScreenW=0, gScreenH=0, gScreenD=0, gScreenF=0
dim shared as uinteger gBackColor=1

'' --------------------------------------------------------------------------
'' PRIVATE FUNCTIONS
'' --------------------------------------------------------------------------

Sub ModeSet(ByVal w As integer, ByVal h As integer, Byval d As Integer, ByVal f As Integer)
	Dim As integer pw = gScreenW
	Dim As integer ph =	gScreenH
	Dim As integer pd =	gScreenD
	Dim As integer pf =	gScreenF
	DIm msg As String
	
	gfx_prepare_set_mode( )
	
	If (fnt <> 0) Then
		FONT_Delete fnt
		fnt = 0
	End If

	msg = "Switching to " & Str(w) & "x" & Ltrim(Str(h)) & "-" & Str(d) & "bit "
	If (f And 1) Then
	  msg = msg & "fullscreen"
	else
	  msg = msg & "windowed"
	End If
	CON_print(msg)

	if gfx_set_mode( w, h, d, f ) then
		gScreenW = w
		gScreenH = h
		gSCreenD = d
		gScreenF = f
		if( d = 8 ) then
			gBackColor = 1
		else
			gBackColor = rgb(63,31,95)			
		end if
	end if

	'' Must update UI's info before reloading fonts
	UI_UpdateScreenInfo(w,h,d)

	''if instr(lcase(command),"-ttf") > 0 then
	''	fnt = FONT_CreateFromTTF(10,"../data/font.ttf")
	''	FONT_Set fnt
	''else		

		fnt = FONT_CreateFromBmp(6,8,"../data/6x8.bmp")
		FONT_Set fnt

	''end if

End Sub

'' --------------------------------------------------------------------------
'' BOX PROCS
'' --------------------------------------------------------------------------

Function Options_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim d As UI_CHECK_T Ptr

	Select Case msgid
	Case UI_MSG_CREATE
		Select Case UI_GetBoxID(box)
		Case 16
			d = UI_GetBoxExtraBytesPtr(box)
			d->Checked = gfx_isVSyncEnabled()
		End Select

	Case UI_MSG_MOUSE_CLICK
		Select Case UI_GetBoxID(box)
		Case 1
			UI_HideBox(gOptions)
		Case 2
			gQuit = TRUE
		Case 3
			StatsDlg_Show
		Case 4
			UI_ShowBox(gTest2)
		Case 5
			ModeSet gScreenW,gScreenH,gScreenD,1
		Case 6
			ModeSet gScreenW,gScreenH,gScreenD,0
		Case 7
			d = UI_GetBoxExtraBytesPtr(box)
			if d->Checked Then
				gfx_EnableVsync()
			else
				gfx_DisableVsync()
			endif
		case 21
			ModeSet 320,200,gScreenD,gScreenF
			UI_PositionBox gOptions, 0, 0
			UI_PositionBox gTest2, 160, 0
			UI_PositionBox gTest2, 160, 0
			''UI_PositionBox gConsole, 160, 100
		case 22
			ModeSet 640,480,gScreenD,gScreenF
		case 23
			ModeSet 800,600,gScreenD,gScreenF
		case 24
			ModeSet 1024,768,gScreenD,gScreenF
		case 31
			ModeSet gScreenW,gScreenH,8,gScreenF
		case 32
			ModeSet gScreenW,gScreenH,15,gScreenF
		case 33
			ModeSet gScreenW,gScreenH,16,gScreenF
		case 34
			ModeSet gScreenW,gScreenH,24,gScreenF
		case 35
			ModeSet gScreenW,gScreenH,32,gScreenF
		case 16
			d = UI_GetBoxExtraBytesPtr(box)
			if (d->checked) Then
				ConsoleDlg_Show
			else
				ConsoleDlg_Hide
			End If
		case else
		  return 1 '' Msg not processed
		End Select

	case else
		return 1 '' Msg not processed
	End Select

End Function

Function Test2_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer

	Dim scr As UI_SCROLL_T Ptr

	Select Case msgid
	case UI_MSG_PAINT
	  Select case UI_GetBoxID(box)
		case 2
			scr = UI_GetBoxExtraBytesPtr(box)
			UI_SetCaptionById gTest2, 3, "Scroll=" & Str(scr->ival)
		End Select
		return 1

	case UI_MSG_CREATE
	  Select Case UI_GetBoxID(box)
		Case 2
			scr = UI_GetBoxExtraBytesPtr(box)
			scr->imin = 0
			scr->imax = 10
			scr->ival = 5
		End Select

	Case UI_MSG_MOUSE_CLICK
		Select Case UI_GetBoxID(box)
		Case 1
			UI_HideBox(gTest2)
		Case 2
			CON_print("Mouse @ (" & Str(msgdata->mx) & "," & Str(msgdata->my) & ")")
		case 9
			Dim As UI_BOX_PTR edt1, edt2
			Dim As UI_INPUT_T ptr d1, d2
			edt1 = UI_GetBoxFromID(UI_GetParentBox(box), 6)
			d1 = UI_GetBoxExtraBytesPtr(edt1)
			edt2 = UI_GetBoxFromID(UI_GetParentBox(box), 7)
			d2 = UI_GetBoxExtraBytesPtr(edt2)
			LINE_BUFFER_SetText(d2->buffer, LINE_BUFFER_GetTextPtr(d1->buffer), LINE_BUFFER_GetLength(d1->buffer))
		case else
			return 1 '' Msg not processed
		End Select

	case UI_MSG_CHANGE
		CON_print("Change @ " & Str(msgdata->mx) & "," & Str(msgdata->my) & ")")

	case else
		return 1 '' Msg not processed
	End Select

End Function

'' --------------------------------------------------------------------------
'' CREATION PROCS
'' --------------------------------------------------------------------------

Function CreateOptions_Dlg(byval owner As UI_BOX_PTR) As UI_BOX_PTR

	Dim As UI_BOX_PTR frm, btn, chk, cap
	Dim c1 As integer = 4
	Dim c2 As Integer = 68
	Dim c3 As Integer = 132

	frm = UI_CreateFrame(owner, 0,10, 10,200,300, @Options_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm,  1, c1, 4 + 24 * 0, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	btn = UI_CreateButton(frm,  2, c1, 4 + 24 * 1, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Quit")
	btn = UI_CreateButton(frm,  3, c1, 4 + 24 * 2, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Stats")
	btn = UI_CreateButton(frm,  4, c1, 4 + 24 * 3, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Test 2")
	btn = UI_CreateButton(frm,  5, c1, 4 + 24 * 4, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Fullscreen")
	btn = UI_CreateButton(frm,  6, c1, 4 + 24 * 5, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Windowed")
	chk = UI_CreateCheck (frm,  7, c1, 4 + 24 * 6, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "VSync")
	cap = UI_CreateCaption(frm, 8, c1, 4 + 24 * 7, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "VSync")
	cap = UI_CreateCaption(frm, 9, c1, 4 + 24 * 8, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "LastKey")
	chk = UI_CreateCheck (frm, 16, c1, 4 + 24 * 9, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "Console")

#ifndef YAGL	
#ifndef MYGL
	''btn = UI_CreateButton(frm, 21, c2, 4 + 24 * 3, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "320x200")
#endif
#endif

	btn = UI_CreateButton(frm, 22, c2, 4 + 24 * 4, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "640x480")
	btn = UI_CreateButton(frm, 23, c2, 4 + 24 * 5, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "800x600")
	btn = UI_CreateButton(frm, 24, c2, 4 + 24 * 6, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "1024x768")

#ifndef YAGL	
#ifndef MYGL
	btn = UI_CreateButton(frm, 31, c3, 4 + 24 * 2, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "8 bit")
	btn = UI_CreateButton(frm, 32, c3, 4 + 24 * 3, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "15 bit")
#endif	
#endif

	btn = UI_CreateButton(frm, 33, c3, 4 + 24 * 4, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "16 bit")
	btn = UI_CreateButton(frm, 34, c3, 4 + 24 * 5, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "24 bit")
	btn = UI_CreateButton(frm, 35, c3, 4 + 24 * 6, 64, 16, @Options_BoxProc, UI_BOX_FLAG_NORMAL, "32 bit")

	Function = frm
End Function


Function CreateTest2_Dlg(byval owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm, btn, vs, cap, edt

	frm = UI_CreateFrame(owner,0,430, 10,200,300, @Test2_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm, 1, 4, 4, 64, 16, @Test2_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	cap = UI_CreateCaption(frm, 3,   4, 24, 64, 16, @Test2_BoxProc, UI_BOX_FLAG_NORMAL, "Scroll=")

	vs = UI_CreateVSCroll(frm, 2, 182,4,10,128, @Test2_BoxProc, UI_BOX_FLAG_NORMAL)

	edt = UI_CreateInput(frm, 6, 8,44,168,12,NULL,UI_BOX_FLAG_NORMAL, "Input1")
	edt = UI_CreateInput(frm, 7, 8,64,168,12,NULL,UI_BOX_FLAG_NORMAL, "Input2")
	edt = UI_CreateEdit(frm, 8, 8,84,168,180,NULL,UI_BOX_FLAG_NORMAL, "Input3")

	btn = UI_CreateButton(frm, 9, 68, 4, 64, 16, @Test2_BoxProc, UI_BOX_FLAG_NORMAL, "Copy")

	Function = frm
End Function

'' --------------------------------------------------------------------------
'' MAIN LOOP
'' --------------------------------------------------------------------------

Sub MainLoop
	Dim As Integer mx,my,mw,mb
	Dim ret As Integer
	Dim k As Integer, kp As String
	stats_init
	stats_mark_start
	Do

		'' -----------------------------------------------
		'' INPUT/GUI
		'' -----------------------------------------------

		k = gfx_GetKeyCode()

		If k = KEY_CLOSE or k = KEY_F10 Then
			Exit Do
		End If
		If k <> KEY_NONE Then
			gLastKey = k
		End If
		If k = KEY_ESCAPE Then
			UI_ShowBox(gOptions)
		End If

		gfx_GetMouse( mx, my, mw, mb )

		If mx >= 0 and my >= 0 Then
			ret = UI_UpdateMouseInfo(NULL, mx, my, mw, mb)
		End If
		if k <> KEY_NONE then
			UI_UpdateKeyInfo NULL, k
		end if

		if stats_ready then	
			stats_reset
			StatsDlg_Update
		  ''UI_SetCaptionById NULL, 1, Str(Cint(tmr1.rate))
		end if

		UI_SetCaptionById gOptions, 8, "VSync=" & Str(gfx_IsVSyncEnabled())
		UI_SetCaptionById gOptions, 9, "LK=" & hex(gLastKey)

		stats_mark_draw

		'' -----------------------------------------------
		'' DRAWING
		'' -----------------------------------------------
	  
		gfx_lock()
		gfx_vsync()
		
		gfx_draw_background( gBackColor )

		ret = UI_Draw(NULL, 0)
		stats_mark_update
		
		gfx_unlock()
		gfx_flip()

		sleep 1,1

		stats_mark_end
	Loop Until gQuit = TRUE
End Sub


'' --------------------------------------------------------------------------
'' MAIN
'' --------------------------------------------------------------------------

CON_print("Initializing ...")
'' CON_setlogfile "guidemo.log"

ModeSet 640,480,32,0

gOptions = CreateOptions_Dlg(NULL)

gTest2 = CreateTest2_Dlg(NULL)
UI_HideBox gTest2

gCapRate = UI_CreateCaption(NULL, 1, 0, 0, 64, 16, 0, UI_BOX_FLAG_NORMAL, "Rate")
UI_HideBox gCapRate

MainLoop

''FIXME: clean-up 
''UI_DeleteBox gRoot

UI_Close

FONT_Delete fnt
