#ifdef __FB_LINUX__
#include "yaglwrapperlinux.bi"
#else
#include "yaglwrapper.bi"
#endif

#include "jm_gui/jm_gui.bi"

Dim Shared gsurface as YaglGfxSurface = 0

sub gfx_prepare_set_mode( )
	if (gsurface) Then
		YaglGfxDevice_swapBuffers( )
	end if
end sub

function gfx_set_mode( byval w as integer, byval h as integer, byval d as integer, byval f as integer ) as integer

	function = 0

	ScreenRes 320, 200, 32, 0, -1

	if (gsurface) Then
		YaglGfxDevice_destroyAllSurfaces
		YaglGfxDevice_destroyAllFonts
	endif

	if( YaglGfxDevice_setScreenMode( w, h, d, f ) = 0 ) then
		CON_print("Unable to switch mode")
		f = 0
		d = 16
		if( YaglGfxDevice_setScreenMode( w, h, d, f ) = 0 ) then
			CON_print("Unabled to switch to default mode")
		end if
	End if

	YaglGfxDevice_setWindowTitle( "guidemo_yagl demo" )
	gsurface = YaglGfxDevice_createSurface( )
	if( gsurface = 0 ) then
		CON_print("Unable to createSurface")
	else
		function = -1
	end if

end function

Sub gfx_draw_background( byval bc as uinteger )
	YaglGfxDevice_clear rgb(0,0,0)
	YaglGfxDevice_solidbox 0,0,gScreenW-1, gScreenH-1, rgb(63,31,95), 255
end sub
					
sub gfx_EnableVSync()
	YaglGfxDevice_EnableVsynch()
end sub

sub gfx_DisableVSync()
	YaglGfxDevice_DisableVsynch()
end sub

function gfx_IsVSyncEnabled() as integer
	function = YaglGfxDevice_isVSynchEnabled()
end function

sub gfx_flip()
	YaglGfxDevice_swapBuffers( )
end sub

sub gfx_lock()
end sub

sub gfx_unlock()
end sub

function gfx_GetKeyCode() as integer
	function = YaglKeyboard_getKey()
end function

sub gfx_GetMouse( byref mx as integer, byref my as integer, byref mz as integer, byref mb as integer )
	mx = YaglMouse_getX()
	my = YaglMouse_getY()
	mw = YaglMouse_getZ()
	mb = YaglMouse_isLeftButtonPressed()
end sub
