#include "guidemo.bi"
#include "jm_gui/jm_gui.bi"
#include "stats.bi"

Dim Shared gStats as UI_BOX_PTR = 0

Type TIMER_T
	count as integer
	t1 as double
	t2 as double
	valid as integer
	percount as integer
	rate as integer
end type

dim shared as TIMER_T tmr(1 to 4)
dim shared as double t1,t2,t3,t4

public sub Timer_Init(byref tmr as TIMER_T)
	with tmr
		.count = 0
		.t1 = UI_TIMER
		.t2 = .t1
		.valid = 0
	end with
end sub

public sub Timer_Reset(byref tmr as TIMER_T)
	with tmr
		if .count > 0 then
			.percount = int((cdbl(.t2) - cdbl(.t1)) / cdbl(.count) * 1000)
		else
			.percount = 0
		endif
		if (cdbl(.t2) - cdbl(.t1)) > 0 then
			.rate = int(cdbl(.count) / (cdbl(.t2) - cdbl(.t1)))
		else
			.rate = 0
		end if
		.count = 0
		.t1 =.t2
		.valid = 0
	end with
end sub

public sub Timer_Accum(byref tmr as TIMER_T, byval tdiff as double)
	with tmr
		.count += 1
		.t2 += tdiff
	end with
end sub

public sub Timer_Update(byref tmr as TIMER_T)
	with tmr
		.count += 1
		.t2 = UI_TIMER
		if .t2 - .t1 > 1.0 then
			.valid = 1
		end if
	end with
end sub

public sub stats_init
  Timer_Init(tmr(1))
  Timer_Init(tmr(2))
  Timer_Init(tmr(3))
  Timer_Init(tmr(4))
end sub

public sub stats_mark_start	
	TIMER_reset(tmr(1))
	t1 = UI_Timer
end sub

public function stats_ready() as integer
	stats_ready = tmr(1).valid
end function

public sub stats_reset
  Timer_Reset(tmr(1))
  Timer_Reset(tmr(2))
  Timer_Reset(tmr(3))
  Timer_Reset(tmr(4))
end sub

public sub stats_mark_draw
	t2 = UI_TIMER
end sub

public sub stats_mark_update
	t3 = UI_TIMER
end sub

public sub stats_mark_end
	t4 = UI_TIMER
	Timer_Accum(tmr(2), t2-t1)
	Timer_Accum(tmr(3), t3-t2)
	Timer_Accum(tmr(4), t4-t3)
	Timer_Update(tmr(1))
	t1 = t4
end sub

public function stats_get_count(byval index as integer) as integer
	function = tmr(index).percount
end function

public function stats_get_rate(byval index as integer) as integer
	function = tmr(index).rate
end function

