#include "guidemo.bi"
#include "jm_gui/jm_gui.bi"
#include "stats.bi"

Dim Shared gStats as UI_BOX_PTR = 0

private Function StatsDlg_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Select Case msgid
	Case UI_MSG_MOUSE_CLICK
		Select Case UI_GetBoxID(box)
		Case 1
			UI_HideBox(gStats)
		case else
			return 1 '' Msg not processed
		End Select
	case else
		return 1 '' Msg not processed
	End Select
End Function


private Function StatsDlg_Create(byval owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm, btn, cap
	Dim As Integer i, x, y, xx, yy

	frm = UI_CreateFrame(owner,0,220, 10,200,300, @StatsDlg_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm,  1,   4,  4, 64, 16, @StatsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	cap = UI_CreateCaption(frm, 2,   4, 24, 64, 16, @StatsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Caption")

	For x = 0 To 2
	  For y = 0 To 4
		  i = 100 + 10 * y + x
			xx = 4 + 64 * x
			yy = 104 + 20 * y
			cap = UI_CreateCaption(frm, i,  xx, yy, 60, 16, @StatsDlg_BoxProc, UI_BOX_FLAG_NORMAL, Str(i))
		Next y
	Next x

	UI_SetCaption UI_GetBoxFromID(frm, 100), "Stats"

	UI_SetCaption UI_GetBoxFromID(frm, 101), "Time (ms)"
	UI_SetCaption UI_GetBoxFromID(frm, 102), "Rate (Hz)"

	UI_SetCaption UI_GetBoxFromID(frm, 110), "Input"
	UI_SetCaption UI_GetBoxFromID(frm, 120), "Draw"
	UI_SetCaption UI_GetBoxFromID(frm, 130), "Update"
	UI_SetCaption UI_GetBoxFromID(frm, 140), "Total"

	Function = frm

End Function

public Sub StatsDlg_Show()
	if gStats = NULL then
		gStats = StatsDlg_Create(NULL)		
	end if
	UI_ShowBox gStats
End Sub

public Sub StatsDlg_Hide()
	if (gStats) then
		UI_HideBox gStats
	end if
End Sub

public Sub StatsDlg_Update
	UI_SetCaption UI_GetBoxFromID(gStats, 111), Str(stats_get_count(2))
	UI_SetCaption UI_GetBoxFromID(gStats, 112), Str(stats_get_rate(2))
	UI_SetCaption UI_GetBoxFromID(gStats, 121), Str(stats_get_count(3))
	UI_SetCaption UI_GetBoxFromID(gStats, 122), Str(stats_get_rate(3))
	UI_SetCaption UI_GetBoxFromID(gStats, 131), Str(stats_get_count(4))
	UI_SetCaption UI_GetBoxFromID(gStats, 132), Str(stats_get_rate(4))
	UI_SetCaption UI_GetBoxFromID(gStats, 141), Str(stats_get_count(1))
	UI_SetCaption UI_GetBoxFromID(gStats, 142), Str(stats_get_rate(1))
End Sub