#include "fbgfx.bi"
#include "jm_gui/jm_font_fntfile.bi"
#include "crt/stdio.bi"

sub cvfntfile alias "cvfntfile" (byval w as integer, byval h as integer, byval img as integer ptr, byval handle as integer)
	dim head as JM_FONT_FNT_FILE_T
	dim item as JM_FONT_FNT_CHAR_T
	dim gdat as JM_FONT_FNT_GLYPH_T
	dim tmpch as integer ptr
	dim i as integer, j as integer, sx as integer, sy as integer, pad as integer
	dim b as ubyte = 0

	tmpch = ImageCreate(w,h)
	
	with head
		.sig = cvi("FNT" + chr(0))
		.size = sizeof(JM_FONT_FNT_FILE_T) - 8
		.char1 = 0
		.charn = 256
		.maxw = w
		.maxh = h
		.cax = w
		.cay = h
		.cbx = 0
		.cby = 0
		.reserved = 0
	end with

	put #handle,,head

	pad = (4 - ((w * h) mod 4)) mod 4

	For i = 0 to 255
		with item
			.sig = cvi("CHR" + chr(0))
			.size = sizeof(JM_FONT_FNT_CHAR_T) - 8
			.c0 = i
			.c1 = 0
			.c2 = 0
			.c3 = 0
			.cgx = w
			.cgy = h
			.cax = w
			.cay = h
			.cbx = 0
			.cby = 0
			.doffset = 0
			.reserved = 0

	  end with

		put #handle,,item
	
	next i

	For i = 0 to 255

		with gdat
			.sig = cvi("GLY" + chr(0))
			.size = w * h + pad
		end with

		put #handle,,gdat

		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		Get img, (sx, sy)-(sx + w-1,sy + h-1), tmpch

		for j = 0 to w * h - 1
			if tmpch[j + 1] then	
				b = 255
			else
				b = 0
			end if
			put #handle,,b
		next j

		b = 0
		for j = 1 to pad
			put #handle,,b
		next j

	next i

	i = cvi("END" + chr(0))
	put #handle,,i
	i = 0
	put #handle,,i

	ImageDestroy tmpch
end sub

sub mainx alias "mainx" 

dim w as integer 
dim h as integer
dim i as integer
dim argc as integer = 0, argv(0 to 10) as string
dim strFile1 as string
dim strFile2 as string
dim bhelp as integer = 0

for i = 0 to 10
  if command(i) = "" then exit for
  argv(argc) = command(i)
  argc += 1
next i

if argc = 1 then
  bhelp = 1
else
  for i = 1 to argc
    select case lcase(argv(i))
    case "/?", "/h", "-h", "--help"
      bhelp = 1
    end select
  next i
endif

if bhelp = 1 or argc <> 5 then
  printf(!"usage : bmp2fnt infile width height outfile\n")
  printf(!"converts a bitmap to a font file\n\n")
  printf(!"   infile   input bitmap file (.bmp)\n")
  printf(!"   width    character cell width\n")
  printf(!"   height   character cell height\n")
  printf(!"   outfile  output file (.fnt)\n\n")
  printf(!"bitmap should be 16*width X 16*height in dimension\n")
  printf(!"glyphs on the bitmap should be ordered left to right,\n")
  printf(!"then top to bottom\n\n")
  printf(!"Copyright (C) 2006 Jeff Marshall (coder@execulink.com)\n")
  end
end if

strFile1 = command(1)
w = val(command(2))
h = val(command(3))
strFile2 = command(4)


printf(!"converting %s (%d x %d) => %s\n", strptr(strfile1), w, h, strptr(strfile2))

ScreenRes 320,200,32,1,fb.GFX_NULL
dim tmp As Any Ptr
tmp = ImageCreate(w * 16, h * 16)
if (tmp) Then
	if Bload(strFile1, tmp) = 0 then
	  open strfile2 for output as #1
		close #1
		open strfile2 for binary as #1
		cvfntfile w, h, tmp, 1
		close #1
	end if
else
  printf(!"unable to allocate image buffer\n")
end if
ImageDestroy tmp

end sub

mainx
