#ifndef __INCLUDE_JM_EDIT_BUFFER_BI__
#define __INCLUDE_JM_EDIT_BUFFER_BI__

''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.

#include "jm_gap_buffer.bi"

Type EDIT_BUFFER_T
	mbuffer as GAP_BUFFER_T ptr
	mcurrow as integer
	mrowcount as integer
	mmaxrows as integer
End Type

declare function EDIT_BUFFER_Create alias "EDIT_BUFFER_Create"         (byval startsize as integer) as EDIT_BUFFER_T Ptr
declare sub      EDIT_BUFFER_Destroy alias "EDIT_BUFFER_Destroy"        (byval buf as EDIT_BUFFER_T Ptr)
declare sub      EDIT_BUFFER_Clear alias "EDIT_BUFFER_Clear"          (byval buf as EDIT_BUFFER_T Ptr)
declare function EDIT_BUFFER_GetBufferSize alias "EDIT_BUFFER_GetBufferSize"  (byval buf as EDIT_BUFFER_T ptr) As integer
declare sub      EDIT_BUFFER_SetBufferSize alias "EDIT_BUFFER_SetBufferSize"  (byval buf as EDIT_BUFFER_T ptr, byval size As integer)

declare function EDIT_BUFFER_GetLength alias "EDIT_BUFFER_GetLength"      (byval buf as EDIT_BUFFER_T ptr) As integer
declare function EDIT_BUFFER_GetIndex alias "EDIT_BUFFER_GetIndex"       (byval buf as EDIT_BUFFER_T ptr) As integer
declare sub      EDIT_BUFFER_SetIndex alias "EDIT_BUFFER_SetIndex"       (byval buf as EDIT_BUFFER_T ptr, byval Index As integer)

declare sub      EDIT_BUFFER_InsertChar alias "EDIT_BUFFER_InsertChar"     (byval buf as EDIT_BUFFER_T Ptr, byval ch As Integer)
declare sub      EDIT_BUFFER_BackChar alias "EDIT_BUFFER_BackChar"       (byval buf as EDIT_BUFFER_T Ptr)
declare sub      EDIT_BUFFER_DeleteChar alias "EDIT_BUFFER_DeleteChar"     (byval buf as EDIT_BUFFER_T Ptr)
declare function EDIT_BUFFER_GetChar alias "EDIT_BUFFER_GetChar"        (byval buf as EDIT_BUFFER_T Ptr, byval Index As integer) As Integer
declare sub      EDIT_BUFFER_SetChar alias "EDIT_BUFFER_SetChar"        (byval buf as EDIT_BUFFER_T Ptr, byval Index As integer, byval ch As Integer)
declare function EDIT_BUFFER_GetText alias "EDIT_BUFFER_GetText"        (byval buf as EDIT_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer
declare function EDIT_BUFFER_SetText alias "EDIT_BUFFER_SetText"        (byval buf as EDIT_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer

declare sub      EDIT_BUFFER_ClearChanged alias "EDIT_BUFFER_ClearChanged"   (byval buf as EDIT_BUFFER_T Ptr)
declare function EDIT_BUFFER_IsChanged alias "EDIT_BUFFER_IsChanged"      (byval buf as EDIT_BUFFER_T Ptr) as integer

#endif
