#ifndef __INCLUDE_JM_GAP_BUFFER_BI__
#define __INCLUDE_JM_GAP_BUFFER_BI__

''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.

const GAP_BUFFER_FLAG_CHANGED = 1

Type GAP_BUFFER_T
	mdata as ubyte ptr
	msize as integer
	mflags as integer
	mindex as integer
	mGap1 as integer
	mGap2 as integer
End Type

declare function GAP_BUFFER_Create alias "GAP_BUFFER_Create"         (byval startsize as integer) as GAP_BUFFER_T Ptr
declare sub      GAP_BUFFER_Destroy alias "GAP_BUFFER_Destroy"        (byval buf as GAP_BUFFER_T Ptr)
declare sub      GAP_BUFFER_Clear alias "GAP_BUFFER_Clear"          (byval buf as GAP_BUFFER_T Ptr)
declare function GAP_BUFFER_GetBufferSize alias "GAP_BUFFER_GetBufferSize"  (byval buf as GAP_BUFFER_T ptr) As integer
declare sub      GAP_BUFFER_SetBufferSize alias "GAP_BUFFER_SetBufferSize"  (byval buf as GAP_BUFFER_T ptr, byval size As integer)

declare function GAP_BUFFER_GetLength alias "GAP_BUFFER_GetLength"      (byval buf as GAP_BUFFER_T ptr) As integer
declare function GAP_BUFFER_GetIndex alias "GAP_BUFFER_GetIndex"       (byval buf as GAP_BUFFER_T ptr) As integer
declare sub      GAP_BUFFER_SetIndex alias "GAP_BUFFER_SetIndex"       (byval buf as GAP_BUFFER_T ptr, byval Index As integer)

declare sub      GAP_BUFFER_InsertChar alias "GAP_BUFFER_InsertChar"     (byval buf as GAP_BUFFER_T Ptr, byval ch As Integer)
declare sub      GAP_BUFFER_BackChar alias "GAP_BUFFER_BackChar"       (byval buf as GAP_BUFFER_T Ptr)
declare sub      GAP_BUFFER_DeleteChar alias "GAP_BUFFER_DeleteChar"     (byval buf as GAP_BUFFER_T Ptr)
declare function GAP_BUFFER_GetChar alias "GAP_BUFFER_GetChar"        (byval buf as GAP_BUFFER_T Ptr, byval Index As integer) As Integer
declare sub      GAP_BUFFER_SetChar alias "GAP_BUFFER_SetChar"        (byval buf as GAP_BUFFER_T Ptr, byval Index As integer, byval ch As Integer)
declare function GAP_BUFFER_GetText alias "GAP_BUFFER_GetText"        (byval buf as GAP_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer
declare function GAP_BUFFER_SetText alias "GAP_BUFFER_SetText"        (byval buf as GAP_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer

declare sub      GAP_BUFFER_ClearChanged alias "GAP_BUFFER_ClearChanged"   (byval buf as GAP_BUFFER_T Ptr)
declare function GAP_BUFFER_IsChanged alias "GAP_BUFFER_IsChanged"      (byval buf as GAP_BUFFER_T Ptr) as integer

#endif
