#ifndef __INCLUDE_JM_FONT_FNTFILE_H
#define __INCLUDE_JM_FONT_FNTFILE_H

/*
''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
*/

struct JM_FONT_FNT_FILE_T __attribute__((packed))
{
	int sig         // "FNT\0"
	int size        // sizeof(JM_FONT_FNT_FILE_T) - 8
	int fonttype    // 0 = fixed bitmap, 1 = var-bitmap
	short char1     // 0
	short charn     // 256
	short maxw      // max glyph bitmap width
	short maxh      // max glyph bitmap height
	short cax       // stanard glyph advance width
	short cay       // stanard glyph advance height
	short cbx       // stanard glyph bearing left
	short cby       // stanard glyph bearing top
	int reserved    // reserved must be 0
}:

struct JM_FONT_FNT_CHAR_T __attribute__((packed))
{
	int sig             // "CHR\0"
	int size            // sizeof(JM_FONT_FNT_CHAR_T) - 8
	char c0             // ascii character
	char c1             // '\0'
	char c2							// '\0'
	char c3							// '\0'
	short cgx           // glyph width
	short cgy           // glyph height
	short cax           // glyph advance width
	short cay           // glyph advance height
	short cbx           // glyph bearing left
	short cby           // glyph bearing top
	int doffset         // offset from start of file to glyph data
	int reserved        // reserved
};

struct JM_FONT_FNT_GLYPH_T __attribute__((packed))
{
	int sig             // "GLY\0"
	int size            // length of pixel data
	char pixeldata[]    // pixel data 1 byte/pixel
};

#endif
